<?php

namespace App\Filters\Panel;

use App\Models\Panel\App\ConfigModel;
use CodeIgniter\Filters\FilterInterface;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Exception;

use function PHPUnit\Framework\throwException;

class Installation implements FilterInterface
{
    /**
     * Do whatever processing this filter needs to do.
     * By default it should not return anything during
     * normal execution. However, when an abnormal state
     * is found, it should return an instance of
     * CodeIgniter\HTTP\Response. If it does, script
     * execution will end and that Response will be
     * sent back to the client, allowing for error pages,
     * redirects, etc.
     *
     * @param RequestInterface $request
     * @param array|null       $arguments
     *
     * @return mixed
     */
    public function before(RequestInterface $request, $arguments = null)
    {
        $arguments = $arguments ?? [];
        helper('app');
        try {
            db_connect()->tableExists('options');
            if (!options('appname')) throw new Exception("App Configuration doesn't exist");
            return redirect()->to(dashboard_url());
        } catch (\Throwable $th) {
            if (strpos($th->getMessage(), 'Unable to connect to the database') !== false && !in_array('step1', $arguments)) {
                return redirect()->to('panel/app/install/step/1');
            }
            if (strpos($th->getMessage(), "doesn't exist") !== false && !in_array('step2', $arguments)) {
                return redirect()->to('panel/app/install/step/2');
            }
        }
    }

    /**
     * Allows After filters to inspect and modify the response
     * object as needed. This method does not allow any way
     * to stop execution of other after filters, short of
     * throwing an Exception or Error.
     *
     * @param RequestInterface  $request
     * @param ResponseInterface $response
     * @param array|null        $arguments
     *
     * @return mixed
     */
    public function after(RequestInterface $request, ResponseInterface $response, $arguments = null)
    {
        //
    }
}
